def spinpaste(src, canvas, degrees):
  turtle = makeTurtle(canvas)
  num_steps = 360 / degrees

  for x in range (num_steps + 1):
    negative(src)
    drop(turtle, src)
    turn(turtle, degrees)

def spinpaste2(src, canvas):
  turtle= makeTurtle(canvas)
  drop(turtle, src)
  negative(src)
  turn(turtle, 85)
  drop(turtle, src)
  negative(src)
  rotatecolor(src)
  turn(turtle,85)
  drop(turtle, src)
  rotatecolor(src)
  turn(turtle, 85)
  drop(turtle,src)
  rotatecolor(src)
  turn(turtle, 85)
  drop(turtle, src)

def collage():
  src= makePicture("Trey's greenscreen.jpg")
  canvas= makeEmptyPicture(800,600)
  spinpaste2(src, canvas)
  repaint(canvas)
  writePictureTo(canvas, "Trey's Collage.jpg")



def desktop():
  src= makePicture("Trey's Collage.jpg")
  canvas= makeEmptyPicture(1280,800)
  spinpaste2(src, canvas)
  nebula = makePicture("nebula.jpg")
  mergedpic= mergeimages(nebula, canvas)
  shidokan= makePicture("shidokna.jpg")
  color= makePicture("Blue Hills.jpg")
  pastetransparent3(mergedpic, shidokan, color, 30, 30)
  pastetransparent2(mergedpic, shidokan, 950, 470 )
  repaint(mergedpic)
  writePictureTo(mergedpic, "Trey's Desktop4.jpg")
  

def pastetransparent(back, fore, startX, startY):
  for x in range(1, getWidth(fore)):
    for y in range(1, getHeight(fore)):
      pixel= getPixel(fore, x, y)
      if getRed(pixel) + getGreen(pixel) + getBlue(pixel) > 255*3-200:
        backpixel= getPixel(back, startX + x, startY + y)
        setColor(backpixel, getColor(pixel))

def pastetransparent3(back, fore, color, startX, startY):
  for x in range(1, getWidth(fore)):
    for y in range(1, getHeight(fore)):
      pixel= getPixel(fore, x, y)
      if getRed(pixel) + getGreen(pixel) + getBlue(pixel) > 255*3-200:
        backpixel= getPixel(back, startX + x, startY + y)
        setColor(backpixel, getColor(getPixel(color,x,y)))

def pastetransparent2(back, fore, startX, startY):
  for x in range(1, getWidth(fore)):
    for y in range(1, getHeight(fore)):
      pixel= getPixel(fore, x, y)
      if getRed(pixel) + getGreen(pixel) + getBlue(pixel) < 255*3-200:
        backpixel= getPixel(back, startX + x, startY + y)
        setColor(backpixel, getColor(pixel))



def copyPicture2(sourcePic,canvas,startX, startY):
# Input parameters are source picture, target picture
# target (X,Y) pixel location
  # Now do the actual copying
  targetX = startX
  for sourceX in range (1, getWidth(sourcePic)):
    targetY=startY
    for sourceY in range (1,getHeight(sourcePic)):
      color = getColor(getPixel(sourcePic,sourceX,sourceY))
      setColor(getPixel(canvas,targetX,targetY),color)
      targetY=targetY + 1
    targetX= targetX+1
  show(sourcePic)
  show(canvas)
  return canvas

def negative(source):
  for x in range(1, getWidth(source)):
    for y in range(1, getHeight(source)):
      pixel= getPixel(source, x, y)
      setRed(pixel, 255-getRed(pixel))
      setGreen(pixel, 255- getGreen(pixel))
      setBlue(pixel, 255- getBlue(pixel))

def rotatecolor(source):
  for x in range(1, getWidth(source)):
    for y in range(1, getHeight(source)):
      pixel= getPixel(source, x, y)
      oldred= getRed(pixel)
      setRed(pixel, getGreen(pixel))
      setGreen(pixel, getBlue(pixel))
      setBlue(pixel, oldred)

def mergeimages(image1, image2):
  newimage= makeEmptyPicture(getWidth(image1), getHeight(image1))
  for x in range(1, getWidth(newimage)):
    for y in range(1, getHeight(newimage)):
      pixel1= getPixel(image1, x, y)
      pixel2= getPixel(image2, x, y)
      newRed= getRed(pixel1) * .45 + getRed(pixel2) * .55
      newGreen= getGreen(pixel1) * .45 + getGreen(pixel2) * .55
      newBlue= getBlue(pixel1) * .45 + getBlue(pixel2) * .55
      pixel3= getPixel(newimage, x, y)
      setColor(pixel3, makeColor(newRed,newGreen,newBlue))
  return newimage

